<?php

include("eqitem.php");

function efEqItemsMessages() {
	return array(
		'en' => array(
		'eqitems' => 'Everquest Items'
	), );
}

class eqitems extends SpecialPage {
	
	/**
	 * Constructor
	 */
	public function __construct() {
		global $wgMessageCache;

		foreach( efEqItemsMessages() as $lang => $messages )
			$wgMessageCache->addMessages( $messages, $lang );

		parent::__construct( 'EQItems', 'eqitems' );
	}

	/**
	 * @param $par Parameters passed to the page
	 */
	public function execute( $par ) {
		global $wgUser, $wgRequest, $wgOut, $item_fields, $ITEMSET_URL;
		$this->setHeaders();

		$limitcount = '50';
		$shortcols = "id, name, itemtype, itemclass, slots";
				
		# Keep out blocked users
		if( $wgUser->isBlocked() ) {
			$wgOut->blockedPage();
			return;
		}

		$query = "UPDATE site_stats SET ss_eqfinditem_count = ss_eqfinditem_count + 1";
		mysql_query($query);

		$searchtext = mysql_real_escape_string(($_GET['searchtext']));
		$columns = $item_fields;

		$startrow = intval(mysql_real_escape_string(($_GET['startrow'])));
		if (!$startrow) $startrow = 0;

		$order = mysql_real_escape_string(($_GET['order']));
		if (!$order) $order = "name";

			/* Ensure the order field is valid */
		if (array_key_exists($order, $item_fields)) $order = "name";

			/* Special order fields */
		if ($order == "itemtype") {
			$order = "itemtype, itemclass";
		}
	
		if ($searchtext) { 
			$SearchQuery = 'name LIKE "%'.$searchtext.'%"';
			$query = "SELECT SQL_CALC_FOUND_ROWS ". $shortcols ." FROM eqitems WHERE (".$SearchQuery.") ORDER BY ".$order." LIMIT ".$startrow.",".$limitcount.";";
		}
		else {
			$query = null;
		}

		if ($query) {
			$getquery  = "searchtext=" . $searchtext;
			$getquery1 = $getquery."&order=".$order;
			$querypage = "/wiki/Special:EqItems";

			$itemresults = mysql_query($query);
			
			$result    = mysql_query("SELECT FOUND_ROWS()");
			$totalrows = mysql_fetch_row($result);
			$rowcount  = mysql_num_rows($itemresults);
	
			if ($totalrows) 
				$totalrows = $totalrows[0];
			else
				$totalrows = 0;
		}

		$wgOut->addHTML("<form type='get' action='/wiki/Special:EqItems'>");
		$wgOut->addHTML("<b>Lookup Item</b> <input type='text' name='searchtext' value='". $searchtext ."' size='32' maxlength='64'/>");
		$wgOut->addHTML("<input type='submit' value='Find'/>");
		$wgOut->addHTML("</form><br/>");

		if ($query) {
			$wgOut->addHTML("Found ".$totalrows." matches. ");
			outputPageLinks ($querypage, $getquery1, $startrow, $limitcount, $rowcount, $totalrows);
	
			$count = 0;

			$wgOut->addHTML("<form method='get' action='". $ITEMSET_URL ."'>");
			$wgOut->addHTML("<input type='hidden' name='action' value='add' />");
			$wgOut->addHTML("<table border='1' class='wikitable' cellpadding='2' cellspacing='0'><tr>");
			$wgOut->addHTML("<th><a href='/wiki/Special:EqItems?". $getquery ."&order=name'>Item</a></th>");
			$wgOut->addHTML("<th><a href='/wiki/Special:EqItems?". $getquery ."&order=itemtype'>Type</a></th>");
			$wgOut->addHTML("<th><a href='/wiki/Special:EqItems?". $getquery ."&order=slots'>Slots</a></th>");
			$wgOut->addHTML("<th>&nbsp;</th>");
			$wgOut->addHTML("</tr>");

			while (($row = mysql_fetch_row($itemresults))) {
				$slots = getEqItemSlotShort($row[4]);
				$type  = getEqItemType($row[2], $row[3]);
	
				$wgOut->addHTML("<tr><td align='left'><a href='/wiki/Special:ShowItem?id=".$row[0]."'>".$row[1]."</a></td>");
				$wgOut->addHTML("<td align='center'>". $type ."</td>");
				$wgOut->addHTML("<td align='center'><small>". $slots ."</small></td>");
				$wgOut->addHTML("<td align='center'><small><input type='checkbox' name='itemid[]' value='". $row[0] ."' /></small></td>");
				$wgOut->addHTML("</tr>\n");
	
				$count = $count + 1;
			}
		
			$wgOut->addHTML("</table>");

			$wgOut->addHTML("<p><b>With the Above Checked Items:</b><ul>");
			$wgOut->addHTML("<li>Add to Item Set (Name or ID) <input type='text' value='' name='settext' size='16' maxlength='64'/>");
				$wgOut->addHTML("<input type='submit' value='Add' />");
				$wgOut->addHTML(" &nbsp; <input type='checkbox' value='1' name='createnew' />Create New Set</li>");
			$wgOut->addHTML("</ul></form>");
		}
	}

}

?>
